/*
    Ming, an SWF output library
    Copyright (C) 2001  Opaque Industries - http://www.opaque.net/

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "_cl.h"

#include <math.h>

#include "block.h"
#include "method.h"

int SWF_gNumCharacters;

WM_DLL_A void  WM_DLL_B SWFBlock_setDefined(SWFBlock block)
{
  block->isDefined = TRUE;
}

WM_DLL_A byte WM_DLL_B SWFBlock_isDefined(SWFBlock block)
{
  return block->isDefined;
}


WM_DLL_A void WM_DLL_B destroySWFBlock(SWFBlock block)
{
  if(block->dtor)
    block->dtor(block);
  else
    _free_(block);
}

WM_DLL_A int WM_DLL_B completeSWFBlock(SWFBlock block)
{
  if(!block->completed)
  {
    if(block->complete)
      block->length = block->complete(block);

    block->completed = TRUE;
  }

  if(block->length>62 ||
     block->type == SWF_DEFINELOSSLESS ||
     block->type == SWF_DEFINELOSSLESS2)
    return block->length + 6;
  else
    return block->length + 2;
}

WM_DLL_A int WM_DLL_B  writeSWFBlockToMethod(SWFBlock block,
			  SWFByteOutputMethod method, void *data)
{
  if(!block->completed)
    completeSWFBlock(block);

  /* write header */

  if(block->length>62 ||
     block->type == SWF_DEFINELOSSLESS ||
     block->type == SWF_DEFINELOSSLESS2)
  {
    /* yep, a definebitslossless block has to be long form, even if it's
       under 63 bytes.  how stupid is that? */

    method((byte)(((block->type&0x03)<<6) + 0x3f), data);
    method((byte)((block->type >> 2)&0xff), data);
    methodWriteUInt32(block->length, method, data);
  }
  else
    methodWriteUInt16(block->length + ((block->type)<<6), method, data);

  if(block->writeBlock)
    block->writeBlock(block, method, data);

  return block->length + ((block->length>62)?6:2);
}

WM_DLL_A SWFBlock WM_DLL_B   newEmptySWFBlock(SWFBlocktype type)
{
  SWFBlock block = _calloc_(1, BLOCK_SIZE);
  block->type = type;

  block->writeBlock = NULL;
  block->complete = NULL;
  block->dtor = NULL;
  block->nrecorded=-1;

  return block;
}

WM_DLL_A SWFBlock  WM_DLL_B  newSWFShowFrameBlock()
{
  return newEmptySWFBlock(SWF_SHOWFRAME);
}
WM_DLL_A SWFBlock WM_DLL_B newSWFEndBlock()
{
  return newEmptySWFBlock(SWF_END);
}
WM_DLL_A SWFBlock  WM_DLL_B  newSWFProtectBlock()
{
  return newEmptySWFBlock(SWF_PROTECT);
}

WM_DLL_A SWFBlocktype  WM_DLL_B  SWFBlock_getType(SWFBlock block)
{
  return block->type;
}

static SWFBlock *NewDestructableBlocksAdded;
static int nNewDestructableBlocksAdded;
static int nMaxNewDestructableBlocksAdded;
#define MOVIE_ITEMS_ADDED_INCR 1024

WM_DLL_A void WM_DLL_B MingRecordNewDestructibleBlockAddedWithDtor(SWFBlock item,destroySWFBlockMethod dtor)
{
 int n=sizeof(swfBlock);
 MingRecordNewDestructibleBlockAdded(item);
 item->dtor=dtor;
}

WM_DLL_A void WM_DLL_B MingRecordNewDestructibleBlockAdded(SWFBlock item)
{
 int i=0;
 int n=sizeof(swfBlock);
 if(nNewDestructableBlocksAdded+1>nMaxNewDestructableBlocksAdded)
 {
  int new_nMaxNewDestructableBlocksAdded=nMaxNewDestructableBlocksAdded+MOVIE_ITEMS_ADDED_INCR;
  SWFBlock *NewNewDestructableBlocksAdded=(SWFBlock*)_realloc_((void *)NewDestructableBlocksAdded,new_nMaxNewDestructableBlocksAdded*sizeof(SWFBlock));
  if(NewNewDestructableBlocksAdded)
  {
   NewDestructableBlocksAdded=NewNewDestructableBlocksAdded;
   nMaxNewDestructableBlocksAdded=new_nMaxNewDestructableBlocksAdded;
  }
  else
  {
   return;
  }
 }
 item->nrecorded=nNewDestructableBlocksAdded;
 NewDestructableBlocksAdded[nNewDestructableBlocksAdded++]=item;
 return;
}

WM_DLL_A void WM_DLL_B MingUnRecordNewDestructibleBlockRemoved(SWFBlock item)
{
 int i=item->nrecorded;
 if(i>=0)
 if(NewDestructableBlocksAdded[i]==item)
 {
  NewDestructableBlocksAdded[i]=NULL;
  return;
 }
 return;
}

WM_DLL_A void WM_DLL_B MingRemoveAllDestructibleBlocks(void)
{
 int i=0;
 for(i=0;i<nNewDestructableBlocksAdded;i++)
  if(NewDestructableBlocksAdded[i]&&NewDestructableBlocksAdded[i]->dtor)
  {
   BLOCK(NewDestructableBlocksAdded[i])->dtor(NewDestructableBlocksAdded[i]);
   NewDestructableBlocksAdded[i]=NULL;
  }
 _free_(NewDestructableBlocksAdded);
 nNewDestructableBlocksAdded=0;
 nMaxNewDestructableBlocksAdded=0;
 NewDestructableBlocksAdded=NULL;
 return;
}
  
  
           