/*
    Ming, an SWF output library
    Copyright (C) 2001  Opaque Industries - http://www.opaque.net/

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SWF_OUTPUTBLOCK_H_INCLUDED
#define SWF_OUTPUTBLOCK_H_INCLUDED

#include "libswf.h"
#include "block.h"
#include "output.h"
#include "character.h"
#include "matrix.h"
#include "cxform.h"
#include "exports.h"

struct _outputBlock
{
  swfBlock block;
  SWFOutput output;
};
typedef struct _outputBlock *SWFOutputBlock;

#define SWFOUTPUTBLOCK_SIZE sizeof(struct _outputBlock)

void destroySWFOutputBlock(SWFBlock block);

WM_DLL_A SWFOutputBlock WM_DLL_B newSWFOutputBlock(SWFOutput out, SWFBlocktype type);

WM_DLL_A SWFOutputBlock WM_DLL_B newSWFPlaceObjectBlock(SWFCharacter character, int depth,
				      SWFMatrix matrix, SWFCXform cXform);

WM_DLL_A SWFOutputBlock WM_DLL_B newSWFSetBackgroundBlock(byte r, byte g, byte b);
WM_DLL_A SWFOutputBlock WM_DLL_B newSWFRemoveObjectBlock(SWFCharacter character, int depth);
WM_DLL_A SWFOutputBlock WM_DLL_B newSWFRemoveObject2Block(int depth);
WM_DLL_A SWFOutputBlock WM_DLL_B newSWFFrameLabelBlock(char *string);
WM_DLL_A SWFOutputBlock WM_DLL_B newSWFExportBlock(SWFExports exports, int nExports);

#endif /* SWF_OUTPUTBLOCK_H_INCLUDED */
