/*
    Ming, an SWF output library
    Copyright (C) 2001  Opaque Industries - http://www.opaque.net/

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MING_FILL_H_INCLUDED
#define MING_FILL_H_INCLUDED

#include <stdlib.h>

#include "blocks/swf.h"
#include "position.h"

/* SWFFill adds a position object to manipulate SWFFillStyle's matrix. */

struct _swfFill
{
  SWFFillStyle fillstyle;
  SWFPosition position;
  int nrecord;
};
typedef struct _swfFill *SWFFill;

#define SWFFILL_SIZE (sizeof(struct _swfFill))

WM_DLL_A SWFFill WM_DLL_B  newSWFFill(SWFFillStyle fillstyle);
void destroySWFFill(SWFBlock fill);

WM_DLL_A void WM_DLL_B SWFFill_skewX(SWFFill fill, float x);
WM_DLL_A void WM_DLL_B SWFFill_skewXTo(SWFFill fill, float x);
WM_DLL_A void WM_DLL_B SWFFill_skewY(SWFFill fill, float y);
WM_DLL_A void WM_DLL_B SWFFill_skewYTo(SWFFill fill, float y);
WM_DLL_A void WM_DLL_B SWFFill_scaleX(SWFFill fill, float x);
WM_DLL_A void WM_DLL_B SWFFill_scaleXTo(SWFFill fill, float x);
WM_DLL_A void WM_DLL_B SWFFill_scaleY(SWFFill fill, float y);
WM_DLL_A void WM_DLL_B SWFFill_scaleYTo(SWFFill fill, float y);

WM_DLL_A void WM_DLL_B MingRecordNewFillAdded(SWFFill item);
WM_DLL_A void WM_DLL_B MingUnRecordNewFillRemoved(SWFFill item);
WM_DLL_A void WM_DLL_B MingRemoveAllFills(void);

/* deprecated: */
WM_DLL_A void WM_DLL_B SWFFill_scaleXY(SWFFill fill, float x, float y);
WM_DLL_A void WM_DLL_B SWFFill_scaleXYTo(SWFFill fill, float x, float y);

WM_DLL_A void WM_DLL_B SWFFill_scale(SWFFill fill, float x, float y);
WM_DLL_A void WM_DLL_B SWFFill_scaleTo(SWFFill fill, float x, float y);
WM_DLL_A void WM_DLL_B SWFFill_rotate(SWFFill fill, float degrees);
WM_DLL_A void WM_DLL_B SWFFill_rotateTo(SWFFill fill, float degrees);
WM_DLL_A void WM_DLL_B SWFFill_move(SWFFill fill, float x, float y);
WM_DLL_A void WM_DLL_B SWFFill_moveTo(SWFFill fill, float x, float y);
WM_DLL_A void WM_DLL_B SWFFill_setMatrix(SWFFill fill, float a, float b,
		       float c, float d, float x, float y);

#endif /* MING_FILL_H_INCLUDED */
