#include "blocks/_cl.h"
#ifdef cl_win
#include "win_ming.h"
#include "ming.h"
#include "blocks/MemLeakCheck.h"
int nmovie_info_for_hdcs,max_movie_info_for_hdcs;
#define SELECT_MOVIE_INCR 1024

struct _movie_info_for_hdc
{
  HDC hdc;
  SWFMovie movie;
  int iGDIMaskLevel;
  SWFJpeg jpeg;
  BOOL fill_jpeg;
  POINT pt;
};
typedef struct _movie_info_for_hdc swfMovieInfoForHdc;
typedef struct _movie_info_for_hdc *SWFMovieInfoForHdc;
static swfMovieInfoForHdc zero_movie_info;
static swfMovieInfoForHdc *movie_info_for_hdcs;

WM_DLL_A void WM_DLL_B WinMing_RemoveAllDisplayItems(char remove_forgotten_items)
{
 MingRemoveAllDisplayItems(remove_forgotten_items);
}

// note the search here is inefficiently coded 
// Just loops through the  array until it finds
// the currently selected hdc, and does so at start of every
// gdi call. However normally one only has maybe at most two or three
// hdcs on the go at a time, one for each graphics context, 
// e.g. maybe one for the window one is painting, and one for a bitmap
// to blt to it,

WM_DLL_A void WM_DLL_B WinMing_FreeMovieSelsIfPoss(char free_anyway)
{
 int i=0;
 if(!free_anyway)
 for(i=0;i<nmovie_info_for_hdcs;i++)
  if(movie_info_for_hdcs[i].hdc)
   return;
 if(movie_info_for_hdcs)
  _free_(movie_info_for_hdcs);
 nmovie_info_for_hdcs=max_movie_info_for_hdcs=0;
 movie_info_for_hdcs=NULL;
}

WM_DLL_A void WM_DLL_B WinMing_FreeMovieSels(void)
{
 WinMing_FreeMovieSelsIfPoss(1/*free_anyway*/);
}

WM_DLL_A void WM_DLL_B WinMing_SelectMovie(HDC hdc,SWFMovie m)
{
 int i=0;
 for(i=0;i<nmovie_info_for_hdcs;i++)
  if(movie_info_for_hdcs[i].hdc==NULL)
  {
   memset(&movie_info_for_hdcs[i],0,sizeof(swfMovieInfoForHdc));
   movie_info_for_hdcs[i].hdc=hdc;
   movie_info_for_hdcs[i].movie=m;
   return;
  }
 if(nmovie_info_for_hdcs+1>max_movie_info_for_hdcs)
 {
  int new_max_movie_info_for_hdcs=max_movie_info_for_hdcs+SELECT_MOVIE_INCR;
  swfMovieInfoForHdc *new_movie_info_for_hdcs=(swfMovieInfoForHdc*)
   _realloc_((void *)movie_info_for_hdcs
   ,new_max_movie_info_for_hdcs*sizeof(swfMovieInfoForHdc));
  if(new_movie_info_for_hdcs)
  {
   movie_info_for_hdcs=new_movie_info_for_hdcs;
  }
  else
   return;
 }
 memset(&movie_info_for_hdcs[i],0,sizeof(swfMovieInfoForHdc));
 movie_info_for_hdcs[nmovie_info_for_hdcs].hdc=hdc;
 movie_info_for_hdcs[nmovie_info_for_hdcs++].movie=m;
 return;
}

WM_DLL_A void WM_DLL_B WinMing_UnSelectMovie(HDC hdc,SWFMovie m)
{
 int i=0;
 for(i=0;i<nmovie_info_for_hdcs;i++)
  if(movie_info_for_hdcs[i].hdc)
  if(movie_info_for_hdcs[i].hdc==hdc)
  {
   movie_info_for_hdcs[i].hdc=NULL;
   WinMing_FreeMovieSelsIfPoss(0/*free_anyway*/);
   return;
  }
 return;
}

swfMovieInfoForHdc *MovieInfoForHdc(HDC hdc)
{
 int i=0;
 for(i=0;i<nmovie_info_for_hdcs;i++)
  if(movie_info_for_hdcs[i].hdc==hdc)
  {
   return &movie_info_for_hdcs[i];
  }
 return &zero_movie_info;
}

WM_DLL_A SWFMovie WM_DLL_B WinMing_GetMovieForHdc(HDC hdc)
{
 int i=0;
 for(i=0;i<nmovie_info_for_hdcs;i++)
  if(movie_info_for_hdcs[i].hdc==hdc)
  {
   return movie_info_for_hdcs[i].movie;
  }
 return NULL;
}

char skip_warn;
void WinWarnFunction(char *szmsg)
{
 char *szshow=szmsg;
 char *szmsg2=malloc(strlen(szmsg)+1024);
 if(skip_warn)
  return;
 if(szmsg2)
 {
  sprintf
   (szmsg2,"Warning from Win Ming library:\n\n%s\n\n"
   "Ctrl + Ok to skip this message in future"
   ,szmsg
   );
  szshow=szmsg2;
 }
 MessageBox(NULL,szshow,"Win Ming Warning",MB_ICONEXCLAMATION|MB_TOPMOST|MB_OK);
 if(GetKeyState(VK_CONTROL)<0)
  skip_warn=1;
 if(szmsg2)free(szmsg2);
}

char skip_error;
void WinErrorFunction(char *szmsg)
{
 char *szshow=szmsg;
 char *szmsg2=malloc(strlen(szmsg)+1024);
 if(skip_error)
  return;
 if(szmsg2)
 {
  sprintf
   (szmsg2,"Error message from Win Ming library:\n\n%s\n\n"
   "Close program now?\n\n"
   "Ctrl + No to skip this message in future"
   ,szmsg
   );
  szshow=szmsg2;
 }
 else
  szmsg2=szmsg;
 if(MessageBox(NULL,szshow,"Win Ming Warning",MB_ICONEXCLAMATION|MB_TOPMOST|MB_YESNO|MB_DEFBUTTON2)
    ==IDYES
   )
 {
  if(szmsg2)
   free(szmsg2);
  exit(1);
 }
 if(GetKeyState(VK_CONTROL)<0)
  skip_error=1;
 if(szmsg2)free(szmsg2);
}

WM_DLL_A SWFMovie WM_DLL_B WinMing_StartMovie(int width,int height
                                        ,float frames_per_sec,int nframes)
{
 SWFMovie m = newSWFMovie();
 Ming_init();
 setSWFWarnFunction(WinWarnFunction);
 setSWFErrorFunction(WinErrorFunction);
 SWFMovie_setRate(m,(float)frames_per_sec);
 SWFMovie_setDimension(m, (float)width,(float) height);
 SWFMovie_setNumberOfFrames(m, nframes);
 Ming_setScale(20.0);
 return m;
}

WM_DLL_A int WM_DLL_B WinMing_CloseMovie(SWFMovie m,char *szFileName)
{
 int length = SWFMovie_output_for_file_name(m,szFileName);
 MingRemoveAllDisplayItems(1);
 destroySWFMovie(m);
 WinMing_FreeMovieSels();
 Ming_cleanup();
 return length;
}


WM_DLL_A void WM_DLL_B WinMing_SetGDIMaskLevel(HDC hdc,int ilevel)
{
 // use for drawing masks - roughly equivalent to clipping
 // regions - to start clipping, set the level to 2.
 // To stop masking, set it to 0.
 swfMovieInfoForHdc *movie_info=MovieInfoForHdc(hdc);
 movie_info->iGDIMaskLevel=ilevel;
}

WM_DLL_A void WM_DLL_B WinMing_StartPaintMask(HDC hdc)
{
 WinMing_SetGDIMaskLevel(hdc,2);
}

WM_DLL_A void WM_DLL_B WinMing_StopPaintMask(HDC hdc)
{
 WinMing_SetGDIMaskLevel(hdc,0);
}


WM_DLL_A SWFJpeg WM_DLL_B WinMing_InitJpegFillFromFileName(HDC hdc,char *szJpegFileName)
{
 swfMovieInfoForHdc *movie_info=MovieInfoForHdc(hdc);\
 return movie_info->jpeg = newSWFJpegBitmapForFileName(szJpegFileName);
}


WM_DLL_A void WM_DLL_B WinMing_InitJpegFill(HDC hdc,SWFJpeg jpeg)
{
 swfMovieInfoForHdc *movie_info=MovieInfoForHdc(hdc);\
 movie_info->jpeg = jpeg;
}

WM_DLL_A void WM_DLL_B WinMing_StartJpegFill(HDC hdc)
{
 swfMovieInfoForHdc *movie_info=MovieInfoForHdc(hdc);\
 movie_info->fill_jpeg=TRUE;
}

WM_DLL_A void WM_DLL_B WinMing_StopJpegFill(HDC hdc)
{
 swfMovieInfoForHdc *movie_info=MovieInfoForHdc(hdc);\
 movie_info->fill_jpeg=FALSE;
}


WM_DLL_A BOOL WM_DLL_B WinMing_MoveTo(HDC hdc,int x,int y,POINT *ppt)
{
 swfMovieInfoForHdc *movie_info=MovieInfoForHdc(hdc);\
 if(ppt)
  ppt=&movie_info->pt;
 movie_info->pt.x=x;
 movie_info->pt.y=y;
 return TRUE;
}


WM_DLL_A SWFDisplayItem WM_DLL_B WinMing_Polyline(HDC hdc,POINT *pts,int npts)
{
 SWFDisplayItem d=NULL;
 byte routline=0, goutline=0, boutline=0;
 int width=0;
 byte aoutline=255;
#define VARS_GET_MOVIE_INFO_AND_MAKE_NEW(type,var,newproc)\
 swfMovieInfoForHdc *movie_info=MovieInfoForHdc(hdc);\
 SWFMovie movie=movie_info->movie;\
 SWFJpeg jpeg=movie_info->jpeg;\
 BOOL fill_jpeg=movie_info->fill_jpeg;\
 int iGDIMaskLevel=movie_info->iGDIMaskLevel;\
 type var;\
 if(!movie)\
  return FALSE;\
 var = newproc();
 VARS_GET_MOVIE_INFO_AND_MAKE_NEW(SWFShape,shape,newSWFShape)
 WinMing_FindCurrentPenWidthAndRGB(hdc,&width,&routline,&goutline,&boutline);
 if(iGDIMaskLevel)
  routline=goutline=boutline=255;
 {
  int ipt=0;
  SWFShape_setLine(shape,(short) width, routline, goutline, boutline,(byte)(width==0?0: aoutline));
  SWFShape_movePenTo(shape, (float)pts[0].x, (float)pts[0].y);
  for(ipt=0;ipt<npts;ipt++)
   SWFShape_drawLineTo(shape, (float)pts[ipt].x, (float)pts[ipt].y);
  SWFShape_end(shape);
  d=SWFMovie_add(movie, shape);
 }
 if(iGDIMaskLevel)
  SWFDisplayItem_setMaskLevel(d,iGDIMaskLevel);
 return d;
}

// php ming reference:

// http://si.php.net:8888/manual/en/function.swfgradient.php

/**
Gradient fills are implemented in SWF as a color ramp, mapped onto a square from (-16384, -16384) to (16384, 16384) TWIPS.
**/

WM_DLL_A SWFDisplayItem WM_DLL_B WinMing_GradientFillRect(HDC hdc
               ,int degrees
               ,int left,int top,int right,int bottom
               ,byte rfill, byte gfill, byte bfill, byte afill
               ,byte rfill2, byte gfill2, byte bfill2, byte afill2
               )
{
 SWFDisplayItem d=NULL;
 // uses current pen for outline
 int width=0;
 byte routline=0, goutline=0, boutline=0;
 VARS_GET_MOVIE_INFO_AND_MAKE_NEW(SWFShape,shape,newSWFShape)
 WinMing_FindCurrentPenWidthAndRGB(hdc,&width,&routline,&goutline,&boutline);
 if(iGDIMaskLevel)
  routline=goutline=boutline=rfill=gfill=bfill=rfill2=gfill2=bfill2=255;
 {
  SWFShape shape = newSWFShape();
  SWFGradient gradient=newSWFGradient();
  SWFFill f1;
  SWFGradient_addEntry(gradient,0.0, rfill, gfill, bfill, afill);
  SWFGradient_addEntry(gradient,1.0, rfill2, gfill2, bfill2, afill2);
  f1 =SWFShape_addGradientFill(shape,gradient, SWFFILL_LINEAR_GRADIENT );
  {
    float ratioa=max(1,(right-left)*Ming_scale)/(float)32768;
    float ratiob=max(1,(bottom-top)*Ming_scale)/(float)32768;
    SWFFill_scaleTo(f1,ratiob,ratioa);
  }
  /**
  if((degrees>90-45&&degrees<90+45)||(degrees>270-45&&degrees<270+45))
  {
   float ratio=(float)32768/max(1,(bottom-top)*Ming_scale);
   SWFFill_scaleTo(f1,1/(ratio),1);
  }
  else
  {
   float ratio=(float)32768/max(1,(right-left)*Ming_scale);
   SWFFill_scaleTo(f1,1,ratio/Ming_scale);
  }
  **/
  SWFFill_moveTo(f1,(float)(left+right)/2,(float)(top+bottom)/2);
  SWFFill_rotate(f1,(float)degrees);
  SWFShape_setRightFill(shape, f1);
  SWFShape_setLine(shape, (unsigned short)width, routline, goutline, boutline,(byte)(width==0?0: (byte)0xff));
  SWFShape_movePenTo(shape, (float)left, (float)top);
  SWFShape_drawLineTo(shape,(float)right,(float)top);
  SWFShape_drawLineTo(shape, (float)right, (float)bottom);
  SWFShape_drawLineTo(shape, (float)left,(float)bottom);
  SWFShape_drawLineTo(shape, (float)left,(float)top);
  SWFShape_end(shape);

  d=SWFMovie_add(movie, shape);
 }
 if(iGDIMaskLevel)
  SWFDisplayItem_setMaskLevel(d,iGDIMaskLevel);
 return d;
}


WM_DLL_A SWFDisplayItem WM_DLL_B WinMing_Polygon(HDC hdc,POINT *pts,int npts)
{
 SWFDisplayItem d=NULL;
 byte rfill=0, gfill=0, bfill=0;
 byte afill=255;
 byte routline=0, goutline=0, boutline=0;
 int width=0;
 byte aoutline=255;
 HBRUSH hBrush=NULL;
 VARS_GET_MOVIE_INFO_AND_MAKE_NEW(SWFShape,shape,newSWFShape)
 hBrush=WinMing_FindCurrentBrushRGB(hdc,&rfill,&gfill,&bfill);
 WinMing_FindCurrentPenWidthAndRGB(hdc,&width,&routline,&goutline,&boutline);
 if(iGDIMaskLevel)
  routline=goutline=boutline=rfill=gfill=bfill=255;
 {
  int ipt=0;
  SWFFill f1 = 
   fill_jpeg&&jpeg?SWFShape_addBitmapFill(shape, jpeg, SWFFILL_TILED_BITMAP)
  :hBrush&&hBrush==GetStockObject(NULL_BRUSH)?NULL:SWFShape_addSolidFill(shape, rfill, gfill, bfill, afill);
  if(movie->displayList==NULL)
   ipt=ipt;
  SWFShape_setLine(shape,(short) width, routline, goutline, boutline,(byte)(width==0?0: aoutline));
  if(f1)
   SWFShape_setRightFill(shape, f1);
  SWFShape_movePenTo(shape, (float)pts[0].x, (float)pts[0].y);
  for(ipt=0;ipt<npts;ipt++)
   SWFShape_drawLineTo(shape, (float)pts[ipt].x, (float)pts[ipt].y);
  SWFShape_drawLineTo(shape, (float)pts[0].x, (float)pts[0].y);
  SWFShape_end(shape);
  if(movie->displayList==NULL)
   ipt=ipt;
  d=SWFMovie_add(movie, shape);
 }
 if(iGDIMaskLevel)
  SWFDisplayItem_setMaskLevel(d,iGDIMaskLevel);
 return d;
}

WM_DLL_A SWFDisplayItem WM_DLL_B WinMing_Rectangle(HDC hdc,int left,int top,int right,int bottom)
{
 POINT pts[4];
 pts[0].x=left;
 pts[0].y=top;
 pts[1].x=right;
 pts[1].y=top;
 pts[2].x=right;
 pts[2].y=bottom;
 pts[3].x=left;
 pts[3].y=bottom;
 return WinMing_Polygon(hdc,pts,4);
}


WM_DLL_A SWFDisplayItem WM_DLL_B WinMing_PolyPolygon(HDC hdc,POINT *poly_pts,int *poly_counts,int ncounts)
{
 int ipt=0,icount=0;
 SWFDisplayItem d=NULL;
 for(icount=0;icount<ncounts;icount++)
 {
  int npts=poly_counts[icount];
  d=WinMing_Polygon(hdc,&poly_pts[ipt],npts);
  ipt+=npts;
 }
 return d; // note it returns display itme for the last polygon made only.
}

WM_DLL_A SWFDisplayItem WM_DLL_B WinMing_LineTo(HDC hdc,int x,int y)
{
 SWFDisplayItem d=NULL;
 byte routline=0, goutline=0, boutline=0;
 int width=0;
 byte aoutline=255;
 HPEN hPen=NULL;
 VARS_GET_MOVIE_INFO_AND_MAKE_NEW(SWFShape,shape,newSWFShape)
 hPen=WinMing_FindCurrentPenWidthAndRGB(hdc,&width,&routline,&goutline,&boutline);
 if(iGDIMaskLevel)
  routline=goutline=boutline=255;
 {
  int ipt=0;
  if(hPen&&hPen!=GetStockObject(NULL_PEN))
  {
   SWFShape_setLine(shape, (short)width, routline, goutline, boutline,(byte)(width==0?0: aoutline));
   SWFShape_movePenTo(shape, (float)movie_info->pt.x, (float)movie_info->pt.y);
   SWFShape_drawLineTo(shape,(float) x, (float)y);
  }
  movie_info->pt.x=x;
  movie_info->pt.y=y;
 }
 d=SWFMovie_add(movie, shape);
 if(iGDIMaskLevel)
  SWFDisplayItem_setMaskLevel(d,iGDIMaskLevel);
 return d;
}
 
WM_DLL_A void WM_DLL_B WinMing_FindBrushRGB(HBRUSH hBrush,BYTE *pR,BYTE *pG,BYTE *pB)
{
 /*Find the RGB value for hBrush*/
 LOGBRUSH logbrush;
 if(!hBrush)
 {
  *pR=*pG=*pB=0;
  return;
 }
 GetObject(hBrush,sizeof(LOGBRUSH),(LPSTR)&logbrush);
 {
  COLORREF cr=logbrush.lbColor;
  *pR=GetRValue(cr);
  *pG=GetGValue(cr);
  *pB=GetBValue(cr);
 }
}

WM_DLL_A HBRUSH WM_DLL_B WinMing_FindCurrentBrushRGB(HDC hdc,BYTE *pR,BYTE *pG,BYTE *pB)
{
 // find the current brush selected into the hdc 
 HBRUSH hBrush=SelectObject(hdc,GetStockObject(NULL_BRUSH));
 SelectObject(hdc,hBrush);
 WinMing_FindBrushRGB(hBrush,pR,pG,pB);
 return hBrush;
}
 
WM_DLL_A void WM_DLL_B WinMing_FindPenWidthAndRGB(HPEN hPen,int *pwidth,BYTE *pR,BYTE *pG,BYTE *pB)
{
 /*Find the RGB value for hBrush*/
 LOGPEN logpen;
 if(!hPen)
 {
  *pwidth=1;*pR=*pG=*pB=0;
  return;
 }
 GetObject(hPen,sizeof(LOGPEN),(LPSTR)&logpen);
 {
  COLORREF cr=logpen.lopnColor;
  *pR=GetRValue(cr);
  *pG=GetGValue(cr);
  *pB=GetBValue(cr);
  (*pwidth)=logpen.lopnWidth.x==0?1:(int)logpen.lopnWidth.x;
 }
 if(hPen==GetStockObject(NULL_PEN))
  *pwidth=0;
}

WM_DLL_A HPEN WM_DLL_B WinMing_FindCurrentPenWidthAndRGB(HDC hdc,int *pwidth,BYTE *pR,BYTE *pG,BYTE *pB)
{
 // find the current pen selected into the hdc 
 HPEN hPen=SelectObject(hdc,GetStockObject(NULL_PEN));
 SelectObject(hdc,hPen);
 WinMing_FindPenWidthAndRGB(hPen,pwidth,pR,pG,pB);
 return hPen;
}

WM_DLL_A void WM_DLL_B WinMing_SetBackground(HDC hdc,HBRUSH hBrush)
{
 SWFMovie movie=WinMing_GetMovieForHdc(hdc);
 byte rfill=0, gfill=0, bfill=0;
 WinMing_FindBrushRGB(hBrush,&rfill,&gfill,&bfill);
 SWFMovie_setBackground(movie,rfill,gfill,bfill);
}

WM_DLL_A SWFDisplayItem WM_DLL_B WinMing_DrawCentredText(HDC hdc,int left,int top, int right,int bottom
                      ,char *szText
                     ,SWFFont f,int font_height)
{
 SWFDisplayItem d=NULL;
 // No background colour painted - equivalent to SetBkMode(TRANSPARENT);
 COLORREF cr=GetTextColor(hdc);
 byte br=GetRValue(cr),bg=GetGValue(cr),bb=GetBValue(cr);
 VARS_GET_MOVIE_INFO_AND_MAKE_NEW(SWFText,t,newSWFText)
 SWFText_setFont(t, f);
 SWFText_setHeight(t, (float)font_height);
 if(iGDIMaskLevel)
  br=bg=bb=255;
 SWFText_setColor(t, br,bg,bb, 0xff);
 SWFText_addString(t, szText,NULL);
 d = SWFMovie_add(movie, t);
 {
  int width=(int)SWFText_getStringWidth(t,szText);
  int height=(int)SWFText_getAscent(t)+(int)SWFText_getDescent(t);
  int xmid=(left+right)/2;
  int ymid=(top+bottom)/2;
  left=max(left,xmid-width/2);
  top=max(top,ymid-height/2);
  SWFDisplayItem_move(d,(float)left,(float)top);
 }
 if(iGDIMaskLevel)
  SWFDisplayItem_setMaskLevel(d,iGDIMaskLevel);
 return d;
 return d;
} 

#endif


                       
     